# Sea2D (Sprite Engine Apple 2D)
A 2D Game Sprite Engine written in C++ for macOS

Written using at least Xcode 7.3 or greater on macOS 10.11. Was part of grad school individual research project.

**Note:** None of the art is made by me! Only used for demonstration. Art is made by [Kenney](http://kenney.nl/).

### Features

 - Working C++ powered graphics engine on macOS
 - Data assets to allow tweaking outside engine code using YAML
 - Sprite system using spritesheet texture and YAML data file
 - Bitmap font system using glyph-sheet texture and YAML data file
 - Support for frame-animated sprites
 - Simple scene graph system with Entities (ie: GameObjects) and Behaviors (called "Components" in Unity3D)
 - Floating point math utility functions
 - Fast 3D vector & matrix library as foundation for fast graphics rendering
 - Advanced 2D camera system that allows rendering on a subsection of the game window (or render on the whole window)

![Demo Screenshot](https://codeberg.org/jibran.syed/Sea2D/raw/branch/master/demo_screenshot.png)
